/*************************************************************************
 *
 *  B-Tree / Packed memory array test
 *
 *************************************************************************/
/*
 * Copyright (c) 2004-07    Massachusetts Institute of Technology
 * Copyright (c) 2004-07    Jim Sukha 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/**
 * basics.h
 *
 *    This file contains global constants for the Libxac runtime system
 *     and other flags controlling the runtime behavior.
 */

#ifndef __BASICS_H
#define __BASICS_H


#define FALSE 0
#define TRUE 1
#define SUCCESS 0
#define FAILURE -1

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>

// The maximum size (in pages) of the transactional
//  memory region that we can map.

#define MAX_PAGES 100000
enum { PAGESIZE = 4096};


// Integer size for 32 or 64 bit machine.
//   There are likely better ways to do this.
#ifdef __x86_64
#   define PTR_INT long 
#else
#   define PTR_INT int
#endif


#endif
