/*************************************************************************
 *
 *  Libxac runtime system
 *
 *************************************************************************/
/*
 * Copyright (c) 2004-06    Massachusetts Institute of Technology
 * Copyright (c) 2004-06    Jim Sukha 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


/**
 * diskPageHashTable.h
 * 
 *  Hash table that stores dpPtr's 
 */


#ifndef __DISK_PAGE_HASH_TABLE
#define __DISK_PAGE_HASH_TABLE


#include "logData.h"

#define NULL_KEY -100

// A hash table that takes in a pageNumber,
//  and looks up the dpPtr (diskPage structure)
//  associated with that page.

typedef struct {
  int key;
  dpPtr diskPage;  
} dpPair;



typedef struct dpHashTableStruct dpHashTable;


dpHashTable* createDPHashTable(void);
void insertDiskPage(dpHashTable* htable, int key, dpPtr diskPage);
dpPtr deleteDiskPage(dpHashTable* htable, int key);
dpPtr getDiskPage(dpHashTable* htable, int key);

int containsPage(dpHashTable* htable, int key);

void destroyHashTable(dpHashTable* htable);
void printHashTable(dpHashTable* htable);

inline int hTableSize(dpHashTable* htable);
inline int hTableIsFull(dpHashTable* htable);

#endif
