/*************************************************************************
 *
 *  Libxac runtime system
 *
 *************************************************************************/
/*
 * Copyright (c) 2004-06    Massachusetts Institute of Technology
 * Copyright (c) 2004-06    Jim Sukha 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/**
 * file_defs.h
 *
 *  Structure describing information for a single file.
 */

#ifndef __FILE_DEFS_H
#define __FILE_DEFS_H


#include <stdlib.h>

// For file information.
#define XFNAME_LENGTH 256

typedef int FILE_ID;

enum {NO_FILE_ID = -43};

typedef struct global_file_info {
  char name[XFNAME_LENGTH];
  FILE_ID id;
  size_t length;
} global_file_info;




#endif

